// Name:

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Diagnostics;

namespace Test3
{
	public class FormMain : System.Windows.Forms.Form
	{
		MeasuredValues values;
		int index;			// index of selected item
		double dValue;		// current value

		#region Controls

		private System.Windows.Forms.Button btnAdd;
		private System.Windows.Forms.ColumnHeader colNumber;
		private System.Windows.Forms.ColumnHeader colValue;
		private System.Windows.Forms.ListView listView;
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.MenuItem mnuFile;
		private System.Windows.Forms.MenuItem mnuFileOpen;
		private System.Windows.Forms.MenuItem mnuFileSaveAs;
		private System.Windows.Forms.Label lblValue;
		private System.Windows.Forms.TextBox editValue;
		private System.Windows.Forms.Label lblMeanValue;
		private System.Windows.Forms.Label lblVariance;
		private System.Windows.Forms.TextBox editMeanValue;
		private System.Windows.Forms.TextBox editStandardDeviation;
		private System.Windows.Forms.Button btnUpdate;
		private System.Windows.Forms.Label lblCount;
		private System.Windows.Forms.OpenFileDialog openFileDialog;
		private System.ComponentModel.IContainer components;
		#endregion

		public FormMain()
		{
			InitializeComponent();
			values = new MeasuredValues();
//			btnUpdate.Enabled = false;
//			btnDelete.Enabled = false;
		}

		#region Windows Form Designer generated code
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void InitializeComponent()
		{
			this.lblCount = new System.Windows.Forms.Label();
			this.lblValue = new System.Windows.Forms.Label();
			this.lblMeanValue = new System.Windows.Forms.Label();
			this.lblVariance = new System.Windows.Forms.Label();
			this.editValue = new System.Windows.Forms.TextBox();
			this.editMeanValue = new System.Windows.Forms.TextBox();
			this.editStandardDeviation = new System.Windows.Forms.TextBox();
			this.listView = new System.Windows.Forms.ListView();
			this.colNumber = new System.Windows.Forms.ColumnHeader();
			this.colValue = new System.Windows.Forms.ColumnHeader();
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.mnuFile = new System.Windows.Forms.MenuItem();
			this.mnuFileOpen = new System.Windows.Forms.MenuItem();
			this.mnuFileSaveAs = new System.Windows.Forms.MenuItem();
			this.btnAdd = new System.Windows.Forms.Button();
			this.btnUpdate = new System.Windows.Forms.Button();
			this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.SuspendLayout();
			// 
			// lblCount
			// 
			this.lblCount.Location = new System.Drawing.Point(12, 8);
			this.lblCount.Name = "lblCount";
			this.lblCount.Size = new System.Drawing.Size(68, 16);
			this.lblCount.TabIndex = 5;
			this.lblCount.Text = "Count = 0";
			this.lblCount.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lblValue
			// 
			this.lblValue.Location = new System.Drawing.Point(12, 172);
			this.lblValue.Name = "lblValue";
			this.lblValue.Size = new System.Drawing.Size(68, 20);
			this.lblValue.TabIndex = 0;
			this.lblValue.Text = "Value:";
			this.lblValue.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lblMeanValue
			// 
			this.lblMeanValue.Location = new System.Drawing.Point(12, 32);
			this.lblMeanValue.Name = "lblMeanValue";
			this.lblMeanValue.Size = new System.Drawing.Size(68, 20);
			this.lblMeanValue.TabIndex = 5;
			this.lblMeanValue.Text = "Mean value:";
			this.lblMeanValue.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lblVariance
			// 
			this.lblVariance.Location = new System.Drawing.Point(12, 60);
			this.lblVariance.Name = "lblVariance";
			this.lblVariance.Size = new System.Drawing.Size(68, 20);
			this.lblVariance.TabIndex = 5;
			this.lblVariance.Text = "Std. Dev.:";
			this.lblVariance.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// editValue
			// 
			this.editValue.Location = new System.Drawing.Point(92, 172);
			this.editValue.Name = "editValue";
			this.editValue.Size = new System.Drawing.Size(84, 20);
			this.editValue.TabIndex = 6;
			this.editValue.Text = "10";
			this.editValue.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.editValue.Validating += new System.ComponentModel.CancelEventHandler(this.editValue_Validating);
			// 
			// editMeanValue
			// 
			this.editMeanValue.Location = new System.Drawing.Point(92, 32);
			this.editMeanValue.Name = "editMeanValue";
			this.editMeanValue.ReadOnly = true;
			this.editMeanValue.Size = new System.Drawing.Size(84, 20);
			this.editMeanValue.TabIndex = 2;
			this.editMeanValue.TabStop = false;
			this.editMeanValue.Text = "";
			this.editMeanValue.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// editStandardDeviation
			// 
			this.editStandardDeviation.Location = new System.Drawing.Point(92, 60);
			this.editStandardDeviation.Name = "editStandardDeviation";
			this.editStandardDeviation.ReadOnly = true;
			this.editStandardDeviation.Size = new System.Drawing.Size(84, 20);
			this.editStandardDeviation.TabIndex = 3;
			this.editStandardDeviation.TabStop = false;
			this.editStandardDeviation.Text = "";
			this.editStandardDeviation.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// listView
			// 
			this.listView.Alignment = System.Windows.Forms.ListViewAlignment.Default;
			this.listView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																											  this.colNumber,
																											  this.colValue});
			this.listView.FullRowSelect = true;
			this.listView.GridLines = true;
			this.listView.HideSelection = false;
			this.listView.Location = new System.Drawing.Point(192, 4);
			this.listView.MultiSelect = false;
			this.listView.Name = "listView";
			this.listView.Size = new System.Drawing.Size(132, 188);
			this.listView.TabIndex = 1;
			this.listView.TabStop = false;
			this.listView.View = System.Windows.Forms.View.Details;
			this.listView.SelectedIndexChanged += new System.EventHandler(this.listView_SelectedIndexChanged);
			// 
			// colNumber
			// 
			this.colNumber.Text = "Nr.";
			this.colNumber.Width = 30;
			// 
			// colValue
			// 
			this.colValue.Text = "Value         ";
			this.colValue.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.colValue.Width = 96;
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																											this.mnuFile});
			// 
			// mnuFile
			// 
			this.mnuFile.Index = 0;
			this.mnuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																										  this.mnuFileOpen,
																										  this.mnuFileSaveAs});
			this.mnuFile.Text = "&File";
			// 
			// mnuFileOpen
			// 
			this.mnuFileOpen.Index = 0;
			this.mnuFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.mnuFileOpen.Text = "&Open";
			this.mnuFileOpen.Click += new System.EventHandler(this.mnuFileOpen_Click);
			// 
			// mnuFileSaveAs
			// 
			this.mnuFileSaveAs.Index = 1;
			this.mnuFileSaveAs.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
			this.mnuFileSaveAs.Text = "&Save As...";
			this.mnuFileSaveAs.Click += new System.EventHandler(this.mnuFileSaveAs_Click);
			// 
			// btnAdd
			// 
			this.btnAdd.Location = new System.Drawing.Point(11, 204);
			this.btnAdd.Name = "btnAdd";
			this.btnAdd.Size = new System.Drawing.Size(68, 24);
			this.btnAdd.TabIndex = 7;
			this.btnAdd.Text = "Add";
			this.btnAdd.Click += new System.EventHandler(this.btnAdd_Click);
			// 
			// btnUpdate
			// 
			this.btnUpdate.Location = new System.Drawing.Point(92, 204);
			this.btnUpdate.Name = "btnUpdate";
			this.btnUpdate.Size = new System.Drawing.Size(68, 24);
			this.btnUpdate.TabIndex = 8;
			this.btnUpdate.Text = "Update";
			this.btnUpdate.Click += new System.EventHandler(this.btnUpdate_Click);
			// 
			// openFileDialog
			// 
			this.openFileDialog.Filter = "Data files|*.txt";
			// 
			// FormMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(330, 234);
			this.Controls.Add(this.btnUpdate);
			this.Controls.Add(this.editMeanValue);
			this.Controls.Add(this.editValue);
			this.Controls.Add(this.editStandardDeviation);
			this.Controls.Add(this.lblMeanValue);
			this.Controls.Add(this.listView);
			this.Controls.Add(this.btnAdd);
			this.Controls.Add(this.lblValue);
			this.Controls.Add(this.lblVariance);
			this.Controls.Add(this.lblCount);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Menu = this.mainMenu;
			this.Name = "FormMain";
			this.Text = "Measured values";
			this.ResumeLayout(false);

		}

		[STAThread] static void Main() 
		{
			Application.Run(new FormMain());
		}
		#endregion

		void SaveData(string fileName)
		{
			StreamWriter sw = new StreamWriter(fileName);
			int n = values.Count;
			for (int i = 0; i < n; i++)
			{
				double v = values.GetItem(i);
				sw.WriteLine("{0:f2}", v);
			}
			sw.Close();
		}

		void LoadData(string fileName)
		{
			values.Clear();
			StreamReader sr = new StreamReader(fileName); 
			{
				string line;
				double v;

				while ((line = sr.ReadLine()) != null) 
				{
					Debug.WriteLine(line);
					// to do
					v = 0.0;
					values.Add(v);
				}
				sr.Close();
			}
			GetData();

		}

		void UpdateStatistic()
		{
			// to do
			editStandardDeviation.Text = String.Format("{0:f3}", Math.Sqrt(values.Variance));
			lblCount.Text = String.Format("Count = {0}", values.Count);
		}

		void GetData()
		{
			listView.Items.Clear();
			int n = values.Count;
			for (int i = 0; i < n; i++)
			{
				double v = values.GetItem(i);
				AddItemToListView(i+1, v);
			}
			UpdateStatistic();
//			btnUpdate.Enabled = false;
//			btnDelete.Enabled = false;
		}

		void AddItemToListView(int nr, double v)
		{
			ListViewItem item;
			item = new ListViewItem(nr.ToString("00"));
			item.SubItems.Add(String.Format("{0:f2}", v));
			listView.Items.Add(item);
		}

		private void btnAdd_Click(object sender, System.EventArgs e)
		{
			bool success = values.Add(dValue);
			if (success) 
			{
				int n = values.Count;
				AddItemToListView(n, dValue);
				UpdateStatistic();
			}
			else
			{
				// to do
			}
		}

		private void mnuFileOpen_Click(object sender, System.EventArgs e)
		{
			DialogResult result = openFileDialog.ShowDialog();
			if (result == DialogResult.OK)
			{
				string fileName = openFileDialog.FileName;
				LoadData(fileName);
			}
		}

		private void mnuFileSaveAs_Click(object sender, System.EventArgs e)
		{
			SaveData("Test3.txt");
		}


		private void btnUpdate_Click(object sender, System.EventArgs e)
		{
			// values.SetItem(index, dValue);
			ListViewItem item = listView.Items[index];
			item.SubItems[1].Text = String.Format("{0:f2}", values.GetItem(index));
			UpdateStatistic();	
		}

		private void listView_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (listView.SelectedIndices.Count > 0)
			{
				index = listView.SelectedIndices[0];
				btnUpdate.Enabled = true;
				// btnDelete.Enabled = true;
				editValue.Text = String.Format("{0:f3}", values.GetItem(index));
			}
			else
			{
				btnUpdate.Enabled = false;
				// btnDelete.Enabled = false;
			}
		}

		private void editValue_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			double v;
			try 
			{
				v = double.Parse(editValue.Text);
			}
			catch
			{
				MessageBox.Show("Please enter a number!", "Error");
				e.Cancel = true;
				return;
			}	
			dValue = v;
			e.Cancel = false;
		}

	}
}
